<template>
    <single-pane
      :capt="contractorName"
      :noUrlbacklink="true"
      @stepBack="onStepBack"
    >
      <div class="tabs-container">
        <ob-tabs
          data-qa="contractorTabs"
          @on-change-tab="onChangeTab"
          :items="tabs"
        >
          <template v-if="activeTab === 'info'">
            <div v-if="contractorGroups.length" class="contractor-header">
              <div class="row">
                <div class="col-xs-2">
                  <div class="contractor-header-title">Входит в группы:</div>
                </div>
                <div class="col-xs-10">
                  <div class="contractor-groups">
                    <div
                      class="contractor-group"
                      v-for="group in contractorGroups"
                      :key="group.uuid"
                    >
                      {{ group.title }}
                    </div>
                  </div>
                </div>
              </div>
            </div>

            <ob-table
              group-by="group"
              :columns="columnsInfo"
              :items="itemsInfo"
              :tableLayoutFixed="true"
              :page-limit="Infinity"
              is-fixed-header
              :footer-disabled="true"
            />
          </template>

          <template v-if="activeTab === 'users'">
            <ob-table
              :columns="columnsUsers"
              :items="itemsUsers"
            />
          </template>
        </ob-tabs>
      </div>
<!--      <Chat/>-->
    </single-pane>
</template>

<script>
import api from '@/api';
import { WORKER_ROLE } from '@/resources/enum';
// import Chat from '@/components/chat';
import SinglePane from 'common-components/src/obComponents/obSinglePanels';
import ObTable    from 'common-components/src/obComponents/obTable';
import ObTabs     from 'common-components/src/obComponents/obTabs';

export default {
  name: 'tenders-index',
  components: {
    SinglePane,
    ObTable,
    ObTabs
    //Chat
  },
  computed: {
    uuid: ({ $route }) => $route.params.uuid,

    columnsInfo() {
      return [
        {
          title: 'Наименование поля',
          key: 'title'
        },
        {
          title: 'Значение поля',
          key: 'value',
          html: ({ value }) => typeof value === 'object' ? this.getTitledValuesHtml(value) : value
        },
      ];
    },

    columnsUsers() {
      return [
        {
          title: 'ФИО',
          key: 'fio',
          html: ({ lastName, firstName, patronymic }) => `${firstName} ${lastName} ${patronymic}`
        },
        {
          title: 'Роль пользователя',
          key: 'role',
          html: ({ workerRoleCodes }) => workerRoleCodes.map(roleCode => WORKER_ROLE[roleCode]).join(', ')
        },
        {
          title: 'Эл. почта',
          key: 'email'
        },
      ]
    }
  },
  data() {
    return {
      contractorName: null,
      contractorGroups: [],
      itemsInfo: [],
      itemsUsers: [],

      tabs: [
        {
          title: 'Карточка участника',
          tab: 'info'
        },
        {
          title: 'Пользователи',
          tab: 'users'
        }
      ],
      activeTab: 'info'
    }
  },
  methods: {
    async getContractor() {
      const { domains } = await api.tenders.getContractorByUuid(this.uuid);
      const { groups } = domains[0];

      this.contractorName = domains[0].participantTitle;
      this.contractorGroups = domains[0]?.contractor_groups || [];


      groups
        .sort((a,b) => a.requisiteGroupPosition - b.requisiteGroupPosition)
        .map(group =>
          group.fields
            .sort((a,b) => a.fieldPos - b.fieldPos)
            .map(field => {
              const value = this.getValue(field.fieldValues[0].data)
              if (value) {
                this.itemsInfo.push({
                  value,
                  title: field.fieldTitle,

                  group: group.requisiteGroupTitle
                })
              }
            })
        );

    },

    getValue(data) {
      let value = data.value || data.valuesTitled
      if (value === true) value = 'Да'

      return value
    },

    getTitledValuesHtml(values) {
      return values.map(value => `<div>${value.code} ${value.title}</div>`).join('');
    },

    onStepBack() {
      this.$router.push({ path: '/tenders-contractors' });
    },

    async onChangeTab(e) {
      this.activeTab = e.tab

      if (this.activeTab === 'users' && !this.itemsUsers.length) {
        const { data: { users } } = await api.tendersContractors.getParticipantUsers(this.uuid)

        this.itemsUsers = users
      }
    }
  },
  created() {
    this.getContractor();
  }
};
</script>

<style lang="scss" scoped>
  @import "~common-components/src/assets/style/ob-style";
  @import "~common-components/src/static/css/mixins";

  .tabs-container {
    padding: 20px 18px 0;
    margin-bottom: 40px;
  }

  .contractor-header {
    padding: 0 18px;
    margin-bottom: 30px;
  }

  .contractor-header-title {
    @include font-mixin(14px, 20px, 400, $gray-slate);
  }

  .contractor-groups {
    display: flex;
    flex-wrap: wrap;
  }

  .contractor-group {
    @include font-mixin(14px, 18px, 400, $color-text-base);
    flex: none;
    padding: 5px 12px;
    background: $lavender;
    border-radius: 100px;
    display: flex;
    align-items: center;
    margin: 0 10px 10px 0;
    max-width: 100%;
  }

</style>
